#ifndef __RK4_Nbody_H__INCLUDED
#define __RK4_Nbody_H__INCLUDED

#include "Vector3.h"

class RK4_Nbody {
private:
public:
	//vpeB
	int N;                              //̐
	double dt;                          //ԍݕ
	Vector3 *rs, *vs;                   //ʒuxNgƑxxNg
	Vector3 *drs, *dvs;                 //ʒuxNgƑxxNg̕ω
	//ȉAQENb^@ŗpz
	Vector3 *v1s, *a1s, *_v1s, *_a1s;   //Piڗp
	Vector3 *v2s, *a2s, *_v2s, *_a2s;   //Qiڗp
	Vector3 *v3s, *a3s, *_v3s, *_a3s;   //Riڗp
	Vector3 *v4s, *a4s;                 //Siڗp
	//RXgN^
	RK4_Nbody() {}
	RK4_Nbody(int _N, double _dt) { //ƂK{
		N = _N;
		dt = _dt;
		rs  = new Vector3[N]; vs  = new Vector3[N]; drs  = new Vector3[N]; dvs  = new Vector3[N];
		v1s = new Vector3[N]; a1s = new Vector3[N]; _v1s = new Vector3[N]; _a1s = new Vector3[N];
		v2s = new Vector3[N]; a2s = new Vector3[N]; _v2s = new Vector3[N]; _a2s = new Vector3[N];
		v3s = new Vector3[N]; a3s = new Vector3[N]; _v3s = new Vector3[N]; _a3s = new Vector3[N];
		v4s = new Vector3[N];
		a4s = new Vector3[N];
	}
	//fBXgN^
	virtual ~RK4_Nbody() {
		//Imۂ̊J
		delete[] rs;  delete[] vs;  delete[] drs;  delete[] dvs;
		delete[] v1s; delete[] a1s; delete[] _v1s; delete[] _a1s;
		delete[] v2s; delete[] a2s; delete[] _v2s; delete[] _a2s;
		delete[] v3s; delete[] a3s; delete[] _v3s; delete[] _a3s;
		delete[] v4s; delete[] a4s;
	}
	//xxNg^郁\bh
	virtual void A(double t, Vector3 *rs, Vector3 *vs, Vector3 *out_as);
	//xxNg^郁\bh
	void V(double t, Vector3 *rs, Vector3 *vs, Vector3 *out_vs);
	//ԔWvZ郁\bh
	void timeEvolution(double t);
};

#endif // __RK4_Nbody_H__INCLUDED

